<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>fwConfigurationDB: Recipe Functions</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">fwConfigurationDB
   &#160;<span id="projectnumber">8.4.3</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li class="current"><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('group__RecipeFunctions.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Recipe Functions</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:ga963ab6250237743c7051deb67f0d8366"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga963ab6250237743c7051deb67f0d8366">fwConfigurationDB_GetRecipeFromSystem</a> (dyn_dyn_mixed &amp;recipeObject, dyn_string deviceList, string hierarchyType, dyn_string &amp;exceptionInfo, dyn_string deviceSystems=&quot;&quot;)</td></tr>
<tr class="separator:ga963ab6250237743c7051deb67f0d8366"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga37a32e3745a781b5e285cc1465ccb9ff"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga37a32e3745a781b5e285cc1465ccb9ff">fwConfigurationDB_ApplyRecipe</a> (dyn_dyn_mixed recipeObject, string hierarchyType, dyn_string &amp;exceptionInfo, bool allowApplyRemote=FALSE)</td></tr>
<tr class="separator:ga37a32e3745a781b5e285cc1465ccb9ff"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga464e74b6b3b1faa3cca3826f785bd088"><td class="memItemLeft" align="right" valign="top">string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga464e74b6b3b1faa3cca3826f785bd088">fwConfigurationDB_createRecipeCache</a> (string recipeName, dyn_string &amp;exceptionInfo, string recipeComment=&quot;&quot;, string hierarchyType=&quot;&quot;)</td></tr>
<tr class="separator:ga464e74b6b3b1faa3cca3826f785bd088"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga6c2ad7b1743d9d971cc21ed63cf9cb3d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga6c2ad7b1743d9d971cc21ed63cf9cb3d">fwConfigurationDB_storeRecipeInCache</a> (dyn_dyn_mixed recipeObject, string cacheName, string hierarchyType, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga6c2ad7b1743d9d971cc21ed63cf9cb3d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga97ad266e37b98f3e1b8e0afa1fc597bd"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga97ad266e37b98f3e1b8e0afa1fc597bd">fwConfigurationDB_getRecipeFromCache</a> (string cacheName, dyn_string deviceList, string hierarchyType, dyn_dyn_mixed &amp;recipeObject, dyn_string &amp;exceptionInfo, string systemName=&quot;&quot;)</td></tr>
<tr class="separator:ga97ad266e37b98f3e1b8e0afa1fc597bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga77d7f4f49eeddaffa3457c26767e45e2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga77d7f4f49eeddaffa3457c26767e45e2">fwConfigurationDB_storeDiffRecipeInDB</a> (dyn_dyn_mixed recipeObject, string hierarchyType, string versionDescription, dyn_string &amp;exceptionInfo, string tag, string systemName=&quot;&quot;, bool autoSaveDevices=FALSE)</td></tr>
<tr class="separator:ga77d7f4f49eeddaffa3457c26767e45e2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae1100d8febcde022eef3fd2488312dc3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#gae1100d8febcde022eef3fd2488312dc3">fwConfigurationDB_storeRecipeInDB</a> (dyn_dyn_mixed recipeObject, string hierarchyType, string versionDescription, dyn_string &amp;exceptionInfo, string tag)</td></tr>
<tr class="separator:gae1100d8febcde022eef3fd2488312dc3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8105e46964b2c652460334c0162b8ddd"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga8105e46964b2c652460334c0162b8ddd">fwConfigurationDB_getRecipeFromDB</a> (string topDevice, dyn_string deviceList, string hierarchyType, string tag, dyn_dyn_mixed &amp;recipeObject, dyn_string &amp;exceptionInfo, string systemName=&quot;&quot;, time validAt=0)</td></tr>
<tr class="separator:ga8105e46964b2c652460334c0162b8ddd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaae65e15b082d2cbf72e0cc19570b8bdd"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#gaae65e15b082d2cbf72e0cc19570b8bdd">fwConfigurationDB_makeRecipe</a> (dyn_string deviceElements, dyn_mixed settings, dyn_dyn_mixed &amp;recipeObject, dyn_string &amp;exceptionInfo, bool checkExists=TRUE)</td></tr>
<tr class="separator:gaae65e15b082d2cbf72e0cc19570b8bdd"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader">Public Functions for Recipe Handling</h2></td></tr>
<tr><td class="ititle" colspan="2"><p><a class="anchor" id="amgrp2e2ae64e11f63298474be6b760f36148"></a> Naming conventions:</p><ul>
<li>
operations: <ul>
<li>
load/save From/To Cache/DB  </li>
<li>
extract/apply  </li>
<li>
get Recipes In DB/Cache  </li>
<li>
get/set Description In Cache/DB  </li>
</ul>
</li>
<li>
parameters:<ul>
<li>
recipeObject , recipeObject1, recipeObject2, diffRecipeObject, templateRecipeObject deviceName, deviceList, hierarchyType, recipeName, recipeList </li>
</ul>
</li>
</ul>
<p>Note that the functions used in version 3.0.X will still be supported in 3.1.X, yet their use is deprecated. </p>
</td></tr>
<tr class="memitem:ga90c82b459ca4938b22362a41ffecf141"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga90c82b459ca4938b22362a41ffecf141">fwConfigurationDB_loadRecipeFromCache</a> (string recipeName, dyn_string deviceList, string hierarchyType, dyn_dyn_mixed &amp;recipeObject, dyn_string &amp;exceptionInfo, string systemName=&quot;&quot;)</td></tr>
<tr class="separator:ga90c82b459ca4938b22362a41ffecf141"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga36a6faf13d4f9f4cd17362f5a659e5dc"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga36a6faf13d4f9f4cd17362f5a659e5dc">fwConfigurationDB_loadRecipeFromDB</a> (string recipeName, dyn_string deviceList, string hierarchyType, dyn_dyn_mixed &amp;recipeObject, dyn_string &amp;exceptionInfo, string systemName=&quot;&quot;, string topDevice=&quot;&quot;, time validAt=0)</td></tr>
<tr class="separator:ga36a6faf13d4f9f4cd17362f5a659e5dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga5abee14f21a2a0153cedff1192fe09c5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga5abee14f21a2a0153cedff1192fe09c5">fwConfigurationDB_saveRecipeToDB</a> (dyn_dyn_mixed recipeObject, string hierarchyType, string recipeName, dyn_string &amp;exceptionInfo, string versionDescription=&quot;&quot;, bool autoSaveDevices=FALSE)</td></tr>
<tr class="separator:ga5abee14f21a2a0153cedff1192fe09c5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0bc019a9d021d27bacd6402828b8ab72"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga0bc019a9d021d27bacd6402828b8ab72">fwConfigurationDB_saveRecipeToCache</a> (dyn_dyn_mixed recipeObject, string hierarchyType, string recipeName, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga0bc019a9d021d27bacd6402828b8ab72"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga22139116b5f536eb790becddfe96ced0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga22139116b5f536eb790becddfe96ced0">fwConfigurationDB_saveDiffRecipeToDB</a> (dyn_dyn_mixed recipeObject, string hierarchyType, string recipeName, dyn_string &amp;exceptionInfo, string versionDescription=&quot;&quot;, bool autoSaveDevices=FALSE)</td></tr>
<tr class="separator:ga22139116b5f536eb790becddfe96ced0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad8c78e1c3ab9067aba9ece6320fa5a48"><td class="memItemLeft" align="right" valign="top">synchronized void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#gad8c78e1c3ab9067aba9ece6320fa5a48">fwConfigurationDB_extractRecipe</a> (dyn_string deviceList, string hierarchyType, dyn_dyn_mixed &amp;recipeObject, dyn_string &amp;exceptionInfo, string recipeType=&quot;&quot;, dyn_string deviceSystems=&quot;&quot;, string recipeTypeSystem=&quot;&quot;)</td></tr>
<tr class="separator:gad8c78e1c3ab9067aba9ece6320fa5a48"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga3c127700937f5b3144dcaaaa5c5a7c8a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga3c127700937f5b3144dcaaaa5c5a7c8a">fwConfigurationDB_applyRecipe</a> (dyn_dyn_mixed recipeObject, string hierarchyType, dyn_string &amp;exceptionInfo, bool allowApplyRemote=FALSE)</td></tr>
<tr class="separator:ga3c127700937f5b3144dcaaaa5c5a7c8a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0d9dd8422e251ae9ed2ed47cef94b637"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga0d9dd8422e251ae9ed2ed47cef94b637">fwConfigurationDB_getRecipeDescriptionInCache</a> (string recipeName, string &amp;recipeDescription, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga0d9dd8422e251ae9ed2ed47cef94b637"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga1eae63c6eb2b9e7500407951f50fdda9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga1eae63c6eb2b9e7500407951f50fdda9">fwConfigurationDB_getRecipeDescriptionInDB</a> (string recipeName, string &amp;recipeDescription, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga1eae63c6eb2b9e7500407951f50fdda9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga29e1f652b45e690e290ad9002fb17299"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga29e1f652b45e690e290ad9002fb17299">fwConfigurationDB_setRecipeDescriptionInCache</a> (string recipeName, string recipeDescription, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga29e1f652b45e690e290ad9002fb17299"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga8ab1c049fcfc73d9940fbc3b58eee220"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga8ab1c049fcfc73d9940fbc3b58eee220">fwConfigurationDB_setRecipeDescriptionInDB</a> (string recipeName, string recipeDescription, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:ga8ab1c049fcfc73d9940fbc3b58eee220"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gae452f7467c113afd70b16a9ad13143b1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#gae452f7467c113afd70b16a9ad13143b1">fwConfigurationDB_setRecipeTypeInfoInDB</a> (string recipeName, string recipeTypeName, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:gae452f7467c113afd70b16a9ad13143b1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gadafb27a60dc02862e5017876d4c229df"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#gadafb27a60dc02862e5017876d4c229df">fwConfigurationDB_getRecipesInDB</a> (dyn_string &amp;recipeList, dyn_string &amp;exceptionInfo, string deviceName=&quot;&quot;)</td></tr>
<tr class="separator:gadafb27a60dc02862e5017876d4c229df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaed5760a8cabd9bca77dec1714ac11799"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#gaed5760a8cabd9bca77dec1714ac11799">fwConfigurationDB_getRecipesInCache</a> (dyn_string &amp;recipeList, dyn_string &amp;exceptionInfo, string deviceName=&quot;&quot;, string systemName=&quot;&quot;)</td></tr>
<tr class="separator:gaed5760a8cabd9bca77dec1714ac11799"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga7335b71a07e76cec90ffdc870e86781c"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga7335b71a07e76cec90ffdc870e86781c">fwConfigurationDB_editRecipe</a> (dyn_dyn_mixed &amp;recipeObject, bool readOnly=FALSE, string description=&quot;&quot;)</td></tr>
<tr class="separator:ga7335b71a07e76cec90ffdc870e86781c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac9a61a16359cbaebba3749f765e01f2a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#gac9a61a16359cbaebba3749f765e01f2a">fwConfigurationDB_makeRecipeFromTemplate</a> (dyn_string deviceNames, string hierarchyType, dyn_dyn_mixed templRecipeObject, dyn_dyn_mixed &amp;recipeObject, dyn_string &amp;exceptionInfo)</td></tr>
<tr class="separator:gac9a61a16359cbaebba3749f765e01f2a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa196c19ef16831e8ebccfdfa0b195ecf"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#gaa196c19ef16831e8ebccfdfa0b195ecf">fwConfigurationDB_setRecipeType</a> (string recipeType, dyn_string &amp;exceptionInfo, string systemName=&quot;&quot;)</td></tr>
<tr class="separator:gaa196c19ef16831e8ebccfdfa0b195ecf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gaa03d6c4cc18c9cae3449b957f3b1324e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#gaa03d6c4cc18c9cae3449b957f3b1324e">fwConfigurationDB_combineRecipes</a> (dyn_dyn_mixed &amp;dstRecipeObject, dyn_dyn_mixed srcRecipeObject1, dyn_dyn_mixed srcRecipeObject2, dyn_string &amp;exceptionInfo, string mergeMode=&quot;&quot;)</td></tr>
<tr class="separator:gaa03d6c4cc18c9cae3449b957f3b1324e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga0923dd78679502b1f266ec56ea04104f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga0923dd78679502b1f266ec56ea04104f">fwConfigurationDB_getRecipeMetaInfoInCache</a> (string recipeName, dyn_string &amp;exceptionInfo, string &amp;hierarchyType, string &amp;recipeComment, string &amp;recipeType)</td></tr>
<tr class="separator:ga0923dd78679502b1f266ec56ea04104f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga65ac56de3c92f5cd6249e6aa9dc4bbf4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga65ac56de3c92f5cd6249e6aa9dc4bbf4">fwConfigurationDB_getRecipeMetaInfoInDB</a> (string recipeName, dyn_string &amp;exceptionInfo, string &amp;hierarchyType, string &amp;recipeComment, string &amp;recipeType)</td></tr>
<tr class="separator:ga65ac56de3c92f5cd6249e6aa9dc4bbf4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga9a328ed45e26ce6c6b54f53e77da0b48"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga9a328ed45e26ce6c6b54f53e77da0b48">fwConfigurationDB_findRecipesInCache</a> (dyn_string &amp;recipeNames, dyn_string &amp;exceptionInfo, string recipeName=&quot;*&quot;, string hierarchyType=&quot;*&quot;, string recipeComment=&quot;*&quot;, string recipeType=&quot;*&quot;, string deviceName=&quot;*&quot;, string recipeClass=&quot;*&quot;)</td></tr>
<tr class="separator:ga9a328ed45e26ce6c6b54f53e77da0b48"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga4ca3c4c8273b24ffb4da9cb6900fa60a"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__RecipeFunctions.html#ga4ca3c4c8273b24ffb4da9cb6900fa60a">fwConfigurationDB_findRecipesInDB</a> (dyn_string &amp;recipeNames, dyn_string &amp;exceptionInfo, string recipeName=&quot;*&quot;, string hierarchyType=&quot;&quot;, string recipeComment=&quot;*&quot;, string recipeType=&quot;*&quot;, string deviceName=&quot;*&quot;)</td></tr>
<tr class="separator:ga4ca3c4c8273b24ffb4da9cb6900fa60a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<h2 class="groupheader">Function Documentation</h2>
<a id="ga90c82b459ca4938b22362a41ffecf141"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga90c82b459ca4938b22362a41ffecf141">&#9670;&nbsp;</a></span>fwConfigurationDB_loadRecipeFromCache()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_loadRecipeFromCache </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>deviceList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>systemName</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Loads a recipe from cache to recipe object</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeName</td><td>the name of the recipe cache; could be prefixed with system name and a colon to get recipe from a remote dist system (eg. "dist_2:MYRECIPE"); (see also comments below) </td></tr>
    <tr><td class="paramname">deviceList</td><td>list of the devices for which recipe is loaded; specifying empty list means: load the recipe data for all devices it includes </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>the type of hierarchy (fwDevice_HARDWARE, fwDevice_LOGICAL) </td></tr>
    <tr><td class="paramname">recipeObject</td><td>the recipe data will be stored in this variable </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling routine </td></tr>
    <tr><td class="paramname">systemName</td><td>(compatibility, optional) comma-separated list of system names on which logical device names should be looked up; empty string (default) means that lookup is done on local system only</td></tr>
  </table>
  </dd>
</dl>
<dl class="section note"><dt>Note</dt><dd>In the following cases, logical devices from remote systems will be resolved correctly<ul>
<li>if fwConfigurationDB_allowResolveRemote is set to TRUE, then all connected dist systems will be searched to resolve devices</li>
<li>if systemName parameter is not empty, then it is treated as a comma-separated list of systems to be searched for devices</li>
<li>if a recipe is loaded from a remote system (ie. recipeName parameter is prefixed with system name, then devices will be lookes up in this system.</li>
</ul>
</dd></dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group__RecipeFunctions.html#ga97ad266e37b98f3e1b8e0afa1fc597bd">fwConfigurationDB_getRecipeFromCache</a> </dd></dl>

</div>
</div>
<a id="ga36a6faf13d4f9f4cd17362f5a659e5dc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga36a6faf13d4f9f4cd17362f5a659e5dc">&#9670;&nbsp;</a></span>fwConfigurationDB_loadRecipeFromDB()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_loadRecipeFromDB </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>deviceList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>systemName</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>topDevice</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">time&#160;</td>
          <td class="paramname"><em>validAt</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Loads a recipe from database to recipe object</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeName</td><td>the name of the recipe </td></tr>
    <tr><td class="paramname">deviceList</td><td>list of the devices for which recipe is loaded; specifying empty list means: load the recipe data for all devices it includes </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>the type of hierarchy (fwDevice_HARDWARE, fwDevice_LOGICAL) </td></tr>
    <tr><td class="paramname">recipeObject</td><td>the recipe data will be stored in this variable </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling routine </td></tr>
    <tr><td class="paramname">systemName</td><td>(compatibility, optional) comma-separated list of system names on which logical device names should be looked up; empty string (default) means that lookup is done on local system only </td></tr>
    <tr><td class="paramname">topDevice</td><td>(optional) the name of the top device in the hierarchy, from which the devices should be searched for. Allows to load the recipe for a sub-tree of devices that start at <em>topDevice</em>; it may also speed-up the search in the device tree. <br  />
 By default, empty string is used which means: start the search from the top of the hierachy (i.e. search through the complete list of devices).</td></tr>
    <tr><td class="paramname">validAt</td><td>(optional) allows to query the history of recipes; 0 (default) means: extract the recipe as it is configured now, other date means: extract the recipe as it looked at that date. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group__RecipeFunctions.html#ga8105e46964b2c652460334c0162b8ddd">fwConfigurationDB_getRecipeFromDB</a> </dd></dl>

</div>
</div>
<a id="ga5abee14f21a2a0153cedff1192fe09c5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga5abee14f21a2a0153cedff1192fe09c5">&#9670;&nbsp;</a></span>fwConfigurationDB_saveRecipeToDB()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_saveRecipeToDB </td>
          <td>(</td>
          <td class="paramtype">dyn_dyn_mixed&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>versionDescription</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>autoSaveDevices</em> = <code>FALSE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Saves a recipe contained in recipeObject to the database</p>
<p>If a recipe with specified name already exists, a new version for the recipe is stored - the old settings for the device elements include in the new recipe object are not lost - the history is kept. Otherwise, a new recipe is created in the database.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeObject</td><td>the recipe data that is to be stored </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>the type of hierarchy (fwDevice_HARDWARE, fwDevice_LOGICAL) </td></tr>
    <tr><td class="paramname">recipeName</td><td>the name for the recipe </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling routine </td></tr>
    <tr><td class="paramname">versionDescription</td><td>(optional) description for the new version of recipe data. Note that this is not a recipe comment - it should be rather considered as the documentation of the reason for which the recipe is changed (e.g. like adding a comment when committing changes in CVS). </td></tr>
    <tr><td class="paramname">autoSaveDevices</td><td>if true, the minimal configuration for devices will be stored</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group__RecipeFunctions.html#gae1100d8febcde022eef3fd2488312dc3">fwConfigurationDB_storeRecipeInDB</a> </dd></dl>

</div>
</div>
<a id="ga0bc019a9d021d27bacd6402828b8ab72"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga0bc019a9d021d27bacd6402828b8ab72">&#9670;&nbsp;</a></span>fwConfigurationDB_saveRecipeToCache()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_saveRecipeToCache </td>
          <td>(</td>
          <td class="paramtype">dyn_dyn_mixed&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Saves a recipe contained in recipeObject to the cache</p>
<p>If a recipe cache with specified name already exists, it is overwritten by the new recipe. Otherwise a new recipe cache is created.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeObject</td><td>the recipe data that is to be stored in the cache </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>the type of hierarchy (fwDevice_HARDWARE, fwDevice_LOGICAL) </td></tr>
    <tr><td class="paramname">recipeName</td><td>the name for the recipe cache </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling routine</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group__RecipeFunctions.html#ga6c2ad7b1743d9d971cc21ed63cf9cb3d">fwConfigurationDB_storeRecipeInCache</a> </dd></dl>

</div>
</div>
<a id="ga22139116b5f536eb790becddfe96ced0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga22139116b5f536eb790becddfe96ced0">&#9670;&nbsp;</a></span>fwConfigurationDB_saveDiffRecipeToDB()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_saveDiffRecipeToDB </td>
          <td>(</td>
          <td class="paramtype">dyn_dyn_mixed&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>versionDescription</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>autoSaveDevices</em> = <code>FALSE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Saves a differential recipe to the database</p>
<p>The function compares the data stored in the <em>recipeObject</em> with the data saved in the recipe specified by @recipeName in the database, then stores the changes (differences) to this recipe in the database.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeObject</td><td>the recipe data that is to be stored in the cache </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>the type of hierarchy (fwDevice_HARDWARE, fwDevice_LOGICAL) </td></tr>
    <tr><td class="paramname">recipeName</td><td>the name of the recipe </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling routine </td></tr>
    <tr><td class="paramname">versionDescription</td><td>(optional) description for the new version of recipe data. Note that this is not a recipe comment - it should be rather considered as the documentation of the reason for which the recipe is changed (e.g. like adding a comment when committing changes in CVS).</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group__RecipeFunctions.html#ga77d7f4f49eeddaffa3457c26767e45e2">fwConfigurationDB_storeDiffRecipeInDB</a> </dd></dl>

</div>
</div>
<a id="gad8c78e1c3ab9067aba9ece6320fa5a48"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gad8c78e1c3ab9067aba9ece6320fa5a48">&#9670;&nbsp;</a></span>fwConfigurationDB_extractRecipe()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">synchronized void fwConfigurationDB_extractRecipe </td>
          <td>(</td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>deviceList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeType</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>deviceSystems</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeTypeSystem</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Creates a recipe containing current settings of the system</p>
<p>For a list of devices specified in <em>deviceList</em>, the current values and alarm settings are extracted from the system (according to selected recipe type), and placed in the recipeObject.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">deviceList</td><td>the list of devices to be included in the recipe </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>the type of hierarchy (fwDevice_HARDWARE, fwDevice_LOGICAL) </td></tr>
    <tr><td class="paramname">recipeObject</td><td>the recipe data will be stored in this variable </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling routine </td></tr>
    <tr><td class="paramname">recipeType</td><td>(optional) the recipe type to be used. By default (empty string), the currently selected recipe type will be used. Otherwise, the specified recipe type will be used for this extraction, and then the one used previously will be restored </td></tr>
    <tr><td class="paramname">deviceSystems</td><td>(optional) specifies the systems from which the recipe should be snapshoted; <b>""</b> can be passed to snapshot only the local system and <b>"*"</b> to snapshot all systems </td></tr>
    <tr><td class="paramname">recipeTypeSystem</td><td>(optional) specifies the system from which the recipeType should be retrieved</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group__RecipeFunctions.html#ga963ab6250237743c7051deb67f0d8366">fwConfigurationDB_GetRecipeFromSystem</a> </dd></dl>

</div>
</div>
<a id="ga3c127700937f5b3144dcaaaa5c5a7c8a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga3c127700937f5b3144dcaaaa5c5a7c8a">&#9670;&nbsp;</a></span>fwConfigurationDB_applyRecipe()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_applyRecipe </td>
          <td>(</td>
          <td class="paramtype">dyn_dyn_mixed&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>allowApplyRemote</em> = <code>FALSE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Applies the recipe to the system</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeObject</td><td>the data containing the recipe to be applied </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>the type of hierarchy (fwDevice_HARDWARE, fwDevice_LOGICAL) </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling routine </td></tr>
    <tr><td class="paramname">allowApplyRemote</td><td>if set to TRUE, then it is possible to apply a recipe that contains setting for devices in other systems</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group__RecipeFunctions.html#ga37a32e3745a781b5e285cc1465ccb9ff">fwConfigurationDB_ApplyRecipe</a> </dd></dl>

</div>
</div>
<a id="ga0d9dd8422e251ae9ed2ed47cef94b637"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga0d9dd8422e251ae9ed2ed47cef94b637">&#9670;&nbsp;</a></span>fwConfigurationDB_getRecipeDescriptionInCache()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_getRecipeDescriptionInCache </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>recipeDescription</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets the description of the recipe cache</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeName</td><td>specifies the name of the recipe (cache) </td></tr>
    <tr><td class="paramname">recipeDescription</td><td>on return will contain the description of the recipe </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling routine </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ga1eae63c6eb2b9e7500407951f50fdda9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga1eae63c6eb2b9e7500407951f50fdda9">&#9670;&nbsp;</a></span>fwConfigurationDB_getRecipeDescriptionInDB()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_getRecipeDescriptionInDB </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>recipeDescription</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets the description of the recipe stored in database</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeName</td><td>specifies the name of the recipe </td></tr>
    <tr><td class="paramname">recipeDescription</td><td>on return will contain the description of the recipe </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling routine </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ga29e1f652b45e690e290ad9002fb17299"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga29e1f652b45e690e290ad9002fb17299">&#9670;&nbsp;</a></span>fwConfigurationDB_setRecipeDescriptionInCache()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_setRecipeDescriptionInCache </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeDescription</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets the description of the recipe cache</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeName</td><td>specifies the name of the recipe (cache) </td></tr>
    <tr><td class="paramname">recipeDescription</td><td>should contain the new description for the recipe </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling routine </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ga8ab1c049fcfc73d9940fbc3b58eee220"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga8ab1c049fcfc73d9940fbc3b58eee220">&#9670;&nbsp;</a></span>fwConfigurationDB_setRecipeDescriptionInDB()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_setRecipeDescriptionInDB </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeDescription</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets the description of the recipe in database</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeName</td><td>specifies the name of the recipe (cache) </td></tr>
    <tr><td class="paramname">recipeDescription</td><td>should contain the new description for the recipe </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling routine </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="gae452f7467c113afd70b16a9ad13143b1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gae452f7467c113afd70b16a9ad13143b1">&#9670;&nbsp;</a></span>fwConfigurationDB_setRecipeTypeInfoInDB()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_setRecipeTypeInfoInDB </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeTypeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Sets the recipeType info for the recipe in database</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeName</td><td>specifies the name of the recipe (cache) </td></tr>
    <tr><td class="paramname">recipeTypeName</td><td>should contain the new recipeType for the recipe </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling routine </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="gadafb27a60dc02862e5017876d4c229df"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gadafb27a60dc02862e5017876d4c229df">&#9670;&nbsp;</a></span>fwConfigurationDB_getRecipesInDB()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_getRecipesInDB </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>recipeList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>deviceName</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets the list of recipes available in database</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeList</td><td>on return will contain the list of recipe names (cache names) </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling routine </td></tr>
    <tr><td class="paramname">deviceName</td><td>(optional) the device for which the recipes are being looked-up; specifying empty string (default) returns all available recipes</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group__RecipeFunctions.html#ga4ca3c4c8273b24ffb4da9cb6900fa60a">fwConfigurationDB_findRecipesInDB</a> </dd></dl>

</div>
</div>
<a id="gaed5760a8cabd9bca77dec1714ac11799"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaed5760a8cabd9bca77dec1714ac11799">&#9670;&nbsp;</a></span>fwConfigurationDB_getRecipesInCache()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_getRecipesInCache </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>recipeList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>deviceName</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>systemName</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Gets the list of recipes available in cache on local or remote system</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeList</td><td>on return will contain the list of recipe names </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling routine </td></tr>
    <tr><td class="paramname">deviceName</td><td>(optional) the device for which the recipes are being looked-up; specifying empty string (default) returns all available recipes in the system. </td></tr>
    <tr><td class="paramname">systemName</td><td>allows to get the list of recipe caches on a remote system. passing the "*" value will look up in all dist systems </td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="group__RecipeFunctions.html#ga9a328ed45e26ce6c6b54f53e77da0b48">fwConfigurationDB_findRecipesInCache</a> </dd></dl>

</div>
</div>
<a id="ga7335b71a07e76cec90ffdc870e86781c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga7335b71a07e76cec90ffdc870e86781c">&#9670;&nbsp;</a></span>fwConfigurationDB_editRecipe()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool fwConfigurationDB_editRecipe </td>
          <td>(</td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>readOnly</em> = <code>FALSE</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>description</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Opens recipe editor panel.</p>
<p>May only be used from UI manager.</p>
<dl class="section return"><dt>Returns</dt><dd>TRUE if the recipe was changed (i.e. OK was clicked) </dd></dl>

</div>
</div>
<a id="gac9a61a16359cbaebba3749f765e01f2a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gac9a61a16359cbaebba3749f765e01f2a">&#9670;&nbsp;</a></span>fwConfigurationDB_makeRecipeFromTemplate()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_makeRecipeFromTemplate </td>
          <td>(</td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>deviceNames</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed&#160;</td>
          <td class="paramname"><em>templRecipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Make a recipe out of a recipe template and a list of devices (items)</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">deviceNames</td><td>list of target device (item) names; the must exist in the current system. </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>(dummy) </td></tr>
    <tr><td class="paramname">templRecipeObject</td><td>a recipeObject that contains the recipe template. </td></tr>
    <tr><td class="paramname">recipeObject</td><td>on return the recipe made of template will be appended to this object </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable</td></tr>
  </table>
  </dd>
</dl>
<dl class="reviewed"><dt><b><a class="el" href="reviewed.html#_reviewed000002">Reviewed:</a></b></dt><dd>2018-06-22 <a href="https://readthedocs.web.cern.ch/display/ICKB/FW+Consolidation+Redesign+deprecation+whitelist+reasons#FWConsolidationRedesigndeprecationwhitelistreasons-API">API</a> </dd></dl>

</div>
</div>
<a id="gaa196c19ef16831e8ebccfdfa0b195ecf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaa196c19ef16831e8ebccfdfa0b195ecf">&#9670;&nbsp;</a></span>fwConfigurationDB_setRecipeType()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_setRecipeType </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>systemName</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>sets the recipe type to be used </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeType</td><td>specifies the name of the recipe type </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
    <tr><td class="paramname">systemName</td><td>allows to use recipe type on remote systems </td></tr>
  </table>
  </dd>
</dl>
<dl class="exception"><dt>Exceptions</dt><dd>
  <table class="exception">
    <tr><td class="paramname">exceptionInfo[3]</td><td>may return the following error codes:<ul>
<li><a class="el" href="fwConfigurationDB__Recipes_8ctl.html#a9d12eda09c522b488c9c9e7d4f0811b6">fwConfigurationDB_ERROR_CantLoadPartOfRecipeType</a> (warning)</li>
<li><a class="el" href="fwConfigurationDB__Recipes_8ctl.html#a6c8b979aabc15b9a57d625e4efaaa807">fwConfigurationDB_ERROR_NoRecipeType</a> (error)</li>
<li><a class="el" href="fwConfigurationDB__Recipes_8ctl.html#a01cb45d0fcaad054bf088db975a5278a">fwConfigurationDB_ERROR_CantLoadRecipeType</a> (error)</li>
</ul>
</td></tr>
  </table>
  </dd>
</dl>
<p>If any of the error exceptions was signaled, the current recipe type is reset to an empty recipe.</p>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="index.html#qstart_recipes">Recipes</a> section of Quick Start </dd></dl>

</div>
</div>
<a id="gaa03d6c4cc18c9cae3449b957f3b1324e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaa03d6c4cc18c9cae3449b957f3b1324e">&#9670;&nbsp;</a></span>fwConfigurationDB_combineRecipes()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_combineRecipes </td>
          <td>(</td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>dstRecipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed&#160;</td>
          <td class="paramname"><em>srcRecipeObject1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed&#160;</td>
          <td class="paramname"><em>srcRecipeObject2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>mergeMode</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>combines two recipe objects This function combines two recipe object into third object. For the entries that exist in both source recipes, the one in the second recipe have precedence, and will be used.</p>
<p>The meta-information is treated in the following way: if there is no meta information yet in the first recipe, the meta information from <em>srcRecipeObject2</em> is taken; otherwise, if there is already a meta-information in the <em>srcRecipeObject1</em>, it is discarded except the recipe type name - this one will be set in the <em>dstRecipeObject</em> if it is set in both srcRecipeObjects to equal values.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dstRecipeObject</td><td>on return will contain the combined recipe </td></tr>
    <tr><td class="paramname">srcRecipeObject1</td><td>first recipe to combine </td></tr>
    <tr><td class="paramname">srcRecipeObject2</td><td>second recipe to combine </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
    <tr><td class="paramname">mergeMode</td><td>(optional, default="") determines the mode in which the merge is performed;<ul>
<li>"DEVICE" - for device that is in both recipeObjects, all the elements from recipeObject2 are taken, and nothing from recipeObject1</li>
<li>"ELEMENT" - for device that is in both recipeObjects, all the elements from both recipeObject are used, and when the elements are in both then the settiings from recipeObject2 are taken -"" - take the global setting from <a class="el" href="fwConfigurationDB__Recipes_8ctl.html#aaff1c7f5617ce894e147a2be12b6cf9d">fwConfigurationDB_defaultRecipeMergeMode</a></li>
</ul>
</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="index.html#qstart_recipes">Recipes</a> section of Quick Start </dd></dl>

</div>
</div>
<a id="ga963ab6250237743c7051deb67f0d8366"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga963ab6250237743c7051deb67f0d8366">&#9670;&nbsp;</a></span>fwConfigurationDB_GetRecipeFromSystem()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_GetRecipeFromSystem </td>
          <td>(</td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>deviceList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>deviceSystems</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Reads properties of device(s) from PVSS and stores in recipeObject</p>
<p>This function reads the data from specified data points (devices), according to current recipeType, then appends it to the data already stored in the recipeObject.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeObject</td><td>the structure containing recipe data. The new settings will be appended to it. See also <a class="el" href="index.html#recipeObject">recipeObject</a> data structure description. </td></tr>
    <tr><td class="paramname">deviceList</td><td>list of device names (from whatever hierarchy) </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>hierarchy type - not used anymore! </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
    <tr><td class="paramname">deviceSystems</td><td>comma-separated list of system names at which logical devices will be looked up</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="index.html#qstart_recipes">Recipes</a> section of Quick Start</dd></dl>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000020">Deprecated:</a></b></dt><dd>Please use <a class="el" href="group__RecipeFunctions.html#gad8c78e1c3ab9067aba9ece6320fa5a48">fwConfigurationDB_extractRecipe</a> instead </dd></dl>

</div>
</div>
<a id="ga37a32e3745a781b5e285cc1465ccb9ff"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga37a32e3745a781b5e285cc1465ccb9ff">&#9670;&nbsp;</a></span>fwConfigurationDB_ApplyRecipe()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_ApplyRecipe </td>
          <td>(</td>
          <td class="paramtype">dyn_dyn_mixed&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>allowApplyRemote</em> = <code>FALSE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Applies a recipe stored in recipeObject to the system</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeObject</td><td>the structure containing recipe data. See also <a class="el" href="index.html#recipeObject">recipeObject</a> data structure description. </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>hierarchy type (fwDevice_HARDWARE, fwDevice_LOGICAL, etc) </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
    <tr><td class="paramname">allowApplyRemote</td><td>(optional, default=FALSE) allows to perform dpSet's to remote locations; by default this is disabled (i.e. only local operations allowed) for security</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="index.html#qstart_recipes">Recipes</a> section of Quick Start</dd></dl>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000021">Deprecated:</a></b></dt><dd>use <a class="el" href="group__RecipeFunctions.html#ga3c127700937f5b3144dcaaaa5c5a7c8a">fwConfigurationDB_applyRecipe</a> instead </dd></dl>

</div>
</div>
<a id="ga464e74b6b3b1faa3cca3826f785bd088"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga464e74b6b3b1faa3cca3826f785bd088">&#9670;&nbsp;</a></span>fwConfigurationDB_createRecipeCache()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">string fwConfigurationDB_createRecipeCache </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeComment</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Creates an empty recipe cache </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeName</td><td>the name of the recipe cache </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
    <tr><td class="paramname">recipeComment</td><td>(optional) comment for recipe type </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>(optional) hierarchy type, dummy now! </td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="index.html#qstart_recipes">Recipes</a> section of Quick Start </dd></dl>

</div>
</div>
<a id="ga6c2ad7b1743d9d971cc21ed63cf9cb3d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga6c2ad7b1743d9d971cc21ed63cf9cb3d">&#9670;&nbsp;</a></span>fwConfigurationDB_storeRecipeInCache()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_storeRecipeInCache </td>
          <td>(</td>
          <td class="paramtype">dyn_dyn_mixed&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>cacheName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Saves the recipe in a recipe cache </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeObject</td><td>should contain the recipe data; you may store recipe remotely if you prefix the cacheName with system name. </td></tr>
    <tr><td class="paramname">cacheName</td><td>the name of the cache. Note that if the cache does not exits, it will be created. </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>hierarchy type, dummy now... </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="index.html#qstart_recipes">Recipes</a> section of Quick Start</dd></dl>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000022">Deprecated:</a></b></dt><dd>use <a class="el" href="group__RecipeFunctions.html#ga0bc019a9d021d27bacd6402828b8ab72">fwConfigurationDB_saveRecipeToCache</a> instead </dd></dl>

</div>
</div>
<a id="ga97ad266e37b98f3e1b8e0afa1fc597bd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga97ad266e37b98f3e1b8e0afa1fc597bd">&#9670;&nbsp;</a></span>fwConfigurationDB_getRecipeFromCache()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_getRecipeFromCache </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>cacheName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>deviceList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>systemName</em> = <code>&quot;&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Loads a recipe from recipe cache </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">cacheName</td><td>the name of the recipe cache; could be prefixed with system name and colon </td></tr>
    <tr><td class="paramname">deviceList</td><td>the list of devices for which the recipe should be loaded. specifying empty list means that all devices in the recipe should be loaded </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>hierarchy type, dummy now </td></tr>
    <tr><td class="paramname">recipeObject</td><td>on return will contain the recipe data </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
    <tr><td class="paramname">systemName</td><td>(compatibility, optional) comma-separated list of system names on which logical device names should be looked up; empty string (default) means that lookup is done on local system only</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="index.html#qstart_recipes">Recipes</a> section of Quick Start </dd></dl>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000023">Deprecated:</a></b></dt><dd>use <a class="el" href="group__RecipeFunctions.html#ga90c82b459ca4938b22362a41ffecf141">fwConfigurationDB_loadRecipeFromCache</a> instead</dd></dl>
<dl class="section note"><dt>Note</dt><dd>Please see <a class="el" href="group__RecipeFunctions.html#ga90c82b459ca4938b22362a41ffecf141">fwConfigurationDB_loadRecipeFromCache</a> for full description of functionality, in particular for remote recipes. </dd></dl>

</div>
</div>
<a id="ga77d7f4f49eeddaffa3457c26767e45e2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga77d7f4f49eeddaffa3457c26767e45e2">&#9670;&nbsp;</a></span>fwConfigurationDB_storeDiffRecipeInDB()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_storeDiffRecipeInDB </td>
          <td>(</td>
          <td class="paramtype">dyn_dyn_mixed&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>versionDescription</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>tag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>systemName</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>autoSaveDevices</em> = <code>FALSE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Saves the differences in recipe to the database</p>
<p>This function firstly compares the specified recipe with the one already in the database then stores only the differences</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeObject</td><td>should contain the recipe data to be stored </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>dummy now </td></tr>
    <tr><td class="paramname">versionDescription</td><td>a text describing this version </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
    <tr><td class="paramname">tag</td><td>recipe tag (recipe name)</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="index.html#qstart_recipe_apply">Apply Recipes</a> section of the Quick Start </dd></dl>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000024">Deprecated:</a></b></dt><dd>use <a class="el" href="group__RecipeFunctions.html#ga22139116b5f536eb790becddfe96ced0">fwConfigurationDB_saveDiffRecipeToDB</a> instead </dd></dl>

</div>
</div>
<a id="gae1100d8febcde022eef3fd2488312dc3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gae1100d8febcde022eef3fd2488312dc3">&#9670;&nbsp;</a></span>fwConfigurationDB_storeRecipeInDB()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_storeRecipeInDB </td>
          <td>(</td>
          <td class="paramtype">dyn_dyn_mixed&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>versionDescription</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>tag</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Saves recipe to the database</p>
<p>This function stores a new version of recipe data,</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">recipeObject</td><td>should contain the recipe data to be stored </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>the type of Framework hierarchy: fwDevice_HARDWARE or fwDevice_LOGICAL. </td></tr>
    <tr><td class="paramname">versionDescription</td><td>a text describing this version </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
    <tr><td class="paramname">tag</td><td>recipe name; if empty name is specified, the function will try to figure out the name from the meta-information stored in the recipeObject</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="index.html#qstart_recipe_apply">Apply Recipes</a> section of the Quick Start </dd></dl>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000025">Deprecated:</a></b></dt><dd>use <a class="el" href="group__RecipeFunctions.html#ga5abee14f21a2a0153cedff1192fe09c5">fwConfigurationDB_saveRecipeToDB</a> instead </dd></dl>

</div>
</div>
<a id="ga8105e46964b2c652460334c0162b8ddd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga8105e46964b2c652460334c0162b8ddd">&#9670;&nbsp;</a></span>fwConfigurationDB_getRecipeFromDB()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_getRecipeFromDB </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>topDevice</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>deviceList</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>tag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>systemName</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">time&#160;</td>
          <td class="paramname"><em>validAt</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Loads a recipe from database </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">topDevice</td><td>the top device in the hierarchy - it is a "hint" for the database, telling where to start looking for. An empty string ("") may safely be specified to tell that the devices should be searched for starting from the very top of hierarchy. </td></tr>
    <tr><td class="paramname">deviceList</td><td>the list of devices for which the recipe should be loaded. specifying empty list will result in loading the whole recipe data (for all devices) </td></tr>
    <tr><td class="paramname">hierarchyType</td><td>hierarchy type, dummy parameter now... </td></tr>
    <tr><td class="paramname">tag</td><td>the recipe tag (recipe name) </td></tr>
    <tr><td class="paramname">recipeObject</td><td>on return will contain the recipe data </td></tr>
    <tr><td class="paramname">exceptionInfo</td><td>standard exception handling variable </td></tr>
    <tr><td class="paramname">systemName</td><td>(compatibility, optional) comma-separated list of system names on which logical device names should be looked up; empty string (default) means that lookup is done on local system only param validAt (optional) allow to retrieve a historical version of recipe, as it looked at the point in time specified in this parameter</td></tr>
  </table>
  </dd>
</dl>
<dl class="section see"><dt>See also</dt><dd><a class="el" href="index.html#qstart_recipes">Recipes</a> section of Quick Start </dd></dl>
<dl class="deprecated"><dt><b><a class="el" href="deprecated.html#_deprecated000026">Deprecated:</a></b></dt><dd>use <a class="el" href="group__RecipeFunctions.html#ga36a6faf13d4f9f4cd17362f5a659e5dc">fwConfigurationDB_loadRecipeFromDB</a> instead </dd></dl>

</div>
</div>
<a id="gaae65e15b082d2cbf72e0cc19570b8bdd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#gaae65e15b082d2cbf72e0cc19570b8bdd">&#9670;&nbsp;</a></span>fwConfigurationDB_makeRecipe()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_makeRecipe </td>
          <td>(</td>
          <td class="paramtype">dyn_string&#160;</td>
          <td class="paramname"><em>deviceElements</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_mixed&#160;</td>
          <td class="paramname"><em>settings</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_dyn_mixed &amp;&#160;</td>
          <td class="paramname"><em>recipeObject</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>checkExists</em> = <code>TRUE</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Create an ad-hoc recipeObject based on list of device elements and their settings</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">deviceElements</td><td>list of device elements. The devices may come either from the hardware or from logical view. Each device name should be followed by element name. For instance: dist_1:CAEN/crate1/board00/channel000.settings.v0 (for HARDWARE: it is simply the full data point element name), or MyDetector/ECAL/HV/straw0.settings.i0 (for LOGICAL: it is the device's LOGICAL name followed by the element name, and the element name starts with "." character). </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">settings</td><td>list containing settings for corresponding devices in the <code>deviceElements</code> list. If empty list is passed, these will be snapshotted from the current online values for corresponding dpes </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">recipeObject</td><td>will be filled with the recipe object created from provided input </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">exceptionInfo</td><td>standard exception handling object </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">checkExists</td><td>(optional), if set to TRUE, the list of device elements will be checked to see if all of the specified device elements exist. Should be set to FALSE if a recipeObject is to be created with settings for devices that do not exist yet. Note that without checkExists=TRUE, the recipeObject will have limited usability, namely it cannot be stored to cache or applied to system! In this mode we query aliases from all systems though. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ga0923dd78679502b1f266ec56ea04104f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga0923dd78679502b1f266ec56ea04104f">&#9670;&nbsp;</a></span>fwConfigurationDB_getRecipeMetaInfoInCache()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_getRecipeMetaInfoInCache </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>recipeComment</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>recipeType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Returns meta-information describing a recipe in cache </p>

</div>
</div>
<a id="ga65ac56de3c92f5cd6249e6aa9dc4bbf4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga65ac56de3c92f5cd6249e6aa9dc4bbf4">&#9670;&nbsp;</a></span>fwConfigurationDB_getRecipeMetaInfoInDB()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void fwConfigurationDB_getRecipeMetaInfoInDB </td>
          <td>(</td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>hierarchyType</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>recipeComment</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string &amp;&#160;</td>
          <td class="paramname"><em>recipeType</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Returns meta-information describing a recipe in database </p>

</div>
</div>
<a id="ga9a328ed45e26ce6c6b54f53e77da0b48"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga9a328ed45e26ce6c6b54f53e77da0b48">&#9670;&nbsp;</a></span>fwConfigurationDB_findRecipesInCache()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwConfigurationDB_findRecipesInCache </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>recipeNames</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em> = <code>&quot;*&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em> = <code>&quot;*&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeComment</em> = <code>&quot;*&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeType</em> = <code>&quot;*&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>deviceName</em> = <code>&quot;*&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeClass</em> = <code>&quot;*&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>returns the list of recipes in cache matching specified criteria</p>
<dl class="section return"><dt>Returns</dt><dd>the number of matching recipes found </dd></dl>

</div>
</div>
<a id="ga4ca3c4c8273b24ffb4da9cb6900fa60a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ga4ca3c4c8273b24ffb4da9cb6900fa60a">&#9670;&nbsp;</a></span>fwConfigurationDB_findRecipesInDB()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int fwConfigurationDB_findRecipesInDB </td>
          <td>(</td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>recipeNames</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">dyn_string &amp;&#160;</td>
          <td class="paramname"><em>exceptionInfo</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeName</em> = <code>&quot;*&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>hierarchyType</em> = <code>&quot;&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeComment</em> = <code>&quot;*&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>recipeType</em> = <code>&quot;*&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">string&#160;</td>
          <td class="paramname"><em>deviceName</em> = <code>&quot;*&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>returns the list of recipes in the database matching specified criteria</p>
<dl class="section return"><dt>Returns</dt><dd>the number of matching recipes found, or -1 in case of error </dd></dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1 </li>
  </ul>
</div>
</body>
</html>
